﻿using System;
using RLNET;

namespace RogueLearning
{
    class Program
    {
        private static RLRootConsole _rootConsole;
        private const int screenWidth = 80;
        private const int screenHeight = 24;
        private static int playerX;
        private static int playerY;

        static void Main(string[] args)
        {
            _rootConsole = new RLRootConsole("ascii_8x8.png", screenWidth, screenHeight, 8, 8, 2f, "Rogue Learning");

            _rootConsole.OnLoad += RootConsole_OnLoad;
            _rootConsole.Render += RootConsole_Render;
            _rootConsole.Update += RootConsole_Update;

            _rootConsole.Run();
        }

        private static void RootConsole_Update(object sender, UpdateEventArgs e)
        {
            // Handle keyboard input
            RLKeyPress key = _rootConsole.Keyboard.GetKeyPress();
            if (key != null)
            {
                switch (key.Key)
                {
                    case RLKey.I:
                        playerY -= 1;
                        break;

                    case RLKey.J:
                        playerX -= 1;
                        break;

                    case RLKey.M:
                        playerY += 1;
                        break;

                    case RLKey.K:
                        playerX += 1;
                        break;

                    case RLKey.Q:
                        _rootConsole.Close();
                        break;
                }
            }

            // Ensure player stays on the screen
            if (playerX < 0)
                playerX = 0;
            if (playerX > screenWidth - 1)
                playerX = screenWidth - 1;
            if (playerY < 0)
                playerY = 0;
            if (playerY > screenHeight - 1)
                playerY = screenHeight - 1;
        }

        private static void RootConsole_Render(object sender, UpdateEventArgs e)
        {
            _rootConsole.Clear();

            _rootConsole.SetChar(playerX, playerY, '@');

            _rootConsole.Draw();
        }

        private static void RootConsole_OnLoad(object sender, EventArgs e)
        {
            playerX = screenWidth / 2;
            playerY = screenHeight / 2;
        }
    }
}